QGIS Application - Bug report #18159
Bug on macros(?!)
2018-02-20 05:40 PM - Simon Georget

Status: Closed

Priority: Normal

Assignee:

Category: PyQGIS Console

Affected QGIS version:2.18.16 Regression?: No

Operating System: Ubuntu 16.04 Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 26052
Description

Hi,

| created an OpenProject macro butl get the following error when opening the project.

Une erreur est survenue lors de I'exécution du code suivant:
qgis.utils.reloadProjectMacros()

traceback.print_exception() failed

Version de Python :
2.7.12 (default, Dec 4 2017, 14:50:18)
[GCC 5.4.0 20160609]

Version de QGIS :
2.18.16 'Las Palmas', d473c30

Chemin vers Python :

My macro is running well on python console.
Running the following code in python console again triggers an error :

from qgis.utils import reloadProjectMacros
reloadProjectMacros()

Here is the error message :

reloadProjectMacros()
Traceback (most recent call last):
File "<input>", line 1, in <module>
File "/usr/lib/python2.7/dist-packages/qgis/utils.py”, line 497, in reloadProjectMacros
openProjectMacro()
File "/usr/lib/python2.7/dist-packages/qgis/utils.py”, line 514, in openProjectMacro
mod.openProject()
File "<string>", line 4, in openProject
NameError: global name 'QgsMapLayerRegistry' is not defined
Thanks for you support

History

#1 - 2018-02-21 02:34 PM - Salvatore Larosa
- Status changed from Open to Feedback

Could be your macro missing the import to QgsMapLayerRegistry class? It seems you are using it, isn't?

#2 - 2018-02-21 02:39 PM - Simon Georget

Indeed | do,

Actually my macro is quite basic :

def openProject():
from qgis.gui import QgsMapCanvas;
from qgis.gui import QgsMessageBar;
registry = QgsMapLayerRegistry.instance();
canvas = iface.mapCanvas();
layer = registry.mapLayersByName( 'mylayer" )[0];
canvas.setExtent(layer.extent());
canvas.refresh();

#3 - 2018-02-22 03:44 PM - Regis Haubourg

Hi,

this works here:

from qgis.core import QgsMapLayerRegistry

from qgis.gui import QgsMapCanvas

from qgis.gui import QgsMessageBar

from qgis.utils import iface

canvas = iface.mapCanvas()

registry = QgsMapLayerRegistry.instance()

layer = registry.mapLayersByName( u'tracks (offline)" )[0]
canvas.setExtent(layer.extent())

canvas.refresh()

pass

beware of having the 4 spaces indentations and not tab. | also added import for iface and QgsMapLayerRegistry.

Under linux, the stacktrace is not raised as in windows, which is pretty annoying. See #16923

#4 - 2018-02-22 03:44 PM - Regis Haubourg
- Status changed from Feedback to Closed
- Resolution set to invalid

#5 - 2018-02-22 03:53 PM - Simon Georget

Hi Regis,

Thanks for support but | still have the same issue, even importing iface and QgsMapLayerRegistry (and with 4 spaces indent)

#6 - 2018-02-25 10:45 AM - Simon Georget

- Status changed from Closed to Reopened

#7 - 2018-02-25 05:13 PM - Giovanni Manghi

- Status changed from Reopened to Feedback

- Resolution deleted (invalid)

- Subject changed from Bug on macros !? to Bug on macros(?!)

Simon Georget wrote:

Hi Regis,

Thanks for support but | still have the same issue, even importing iface and QgsMapLayerRegistry (and with 4 spaces indent)

any error?

#8 - 2018-02-25 06:28 PM - Simon Georget

Thanks Giovanni. The error message is provided on the first post.

#9 - 2019-01-21 12:34 AM - Jiirgen Fischer

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#10 - 2019-01-21 09:32 AM - Simon Georget

Jurgen Fischer wrote:

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

Hey Jirgen. Thanks for coming back to me. | still have the same error with 3.4.3-Madeira - revision 2f64a3c
|

Une erreur est survenue lors de I'exécution du code suivant:

qgis.utils.reloadProjectMacros()

Traceback (most recent call last):
File ™, line 1, in

File "/usr/lib/python3/dist-packages/qgis/utils.py", line 499, in reloadProjectMacros
openProjectMacro()

File "/usr/lib/python3/dist-packages/qgis/utils.py", line 516, in openProjectMacro
mod.openProject()

File "™, line 2, in openProject

ImportError: cannot import name 'QgsMapLayerRegistry’

#11 - 2019-01-21 10:35 AM - Nyall Dawson

QgsMapLayerRegistry doesn't exist in 3.x -- you'll need to update your code for the 3.x API.

#12 - 2019-01-21 01:19 PM - Simon Georget

Nyall Dawson wrote:

QgsMapLayerRegistry doesn't exist in 3.x -- you'll need to update your code for the 3.x API.

Indeed. Works well with QgsProject instance. Thanks

Ticket can be closed !

#13 - 2019-01-21 01:40 PM - Jiirgen Fischer
- Resolution set to fixed/implemented
- Status changed from Feedback to Closed
